#version 330 core

layout(location = 0) in vec3 in_vertPos_modelSpace;
layout(location = 1) in vec3 in_normal;
layout(location = 2) in vec2 in_texCoords;

out vec2 vert_texCoords;
out vec3 vert_normal;
out vec3 vert_fragPos;


uniform mat4 u_modelMatrix;
uniform mat4 u_modelMatrixInverseTranspose;

void main() {
	vert_texCoords = in_texCoords;
	vert_normal = vec3(u_modelMatrixInverseTranspose * vec4(in_normal, 1.0f));
	vert_fragPos = (u_modelMatrix * vec4(in_vertPos_modelSpace, 1.0f)).rgb;
}