#version 330 core


in vec2 vert_texCoords;

out vec4 out_fragColor;

uniform sampler2D u_tex;
uniform float u_oneDivViewportWidth;

const float OFFSET[3] = float[](0.0f, 1.3846153846f, 3.2307692308f);
const float WEIGHT[3] = float[](0.2270270270f, 0.3162162162f, 0.0702702703f);

// Source: http://rastergrid.com/blog/2010/09/efficient-gaussian-blur-with-linear-sampling/
void main() {
	vec3 color = texture2D(u_tex, vert_texCoords).rgb * WEIGHT[0];
	
	vec2 offset = vec2(0.0f, 0.0f);
	for (int i = 1; i < 3; i++) {
		offset.y = OFFSET[i] * u_oneDivViewportWidth;
		color += texture2D(u_tex, vert_texCoords + offset).rgb * WEIGHT[i];
		color += texture2D(u_tex, vert_texCoords - offset).rgb * WEIGHT[i];
	}
	
	out_fragColor = vec4(color, 1.0f);
}