#version 330 core

out vec4 out_fragColor;

in vec2 texCoord;
flat in float timeToLive;
flat in int type; // 0=fire, 1=smoke, 2=thingy (forgot the name...)
in vec3 fragPos;

uniform sampler2D texFire;
uniform bool hasTexFire = false;

uniform sampler2D texSmoke;
uniform bool hasTexSmoke = false;

uniform sampler2D texScenePosDis;

uniform float inverseTimeToLiveTotal;

void main() {
	if (timeToLive > 0) {
	
		// Soft particles
		/*vec3 scenePos = texture2D(texScenePosDis, gl_FragCoord.xy / vec2(640, 480)).xyz;
		//float sceneDis = texture2D(texScenePosDis, gl_FragCoord.xy).w;
		float dis = length(scenePos - fragPos);
		float alpha;
		if (dis < 0.5f) {
			alpha = dis * 2.0f;
		} else {
			alpha = 1.0f;
		}*/
	
		const float limit = 0.75f;
		float ttl = timeToLive * inverseTimeToLiveTotal;
		//ttl = ttl < limit ? ttl / limit : 1.0f;
		ttl = clamp(ttl, 0.0f, 1.0f);
	
		/*if (type == 2) {
			if (ttl > 0) {
				out_fragColor = vec4(1.0f, 1.0f, 1.0f, ttl);
				out_fragColor.rgb *= 10.0f;
			} else {
				discard;
			}
		
		} else*/ if (type == 0 && hasTexFire) {
			out_fragColor = texture2D(texFire, texCoord);
			out_fragColor.rgb *= 7.5f * (ttl * 0.5f);
			out_fragColor *= ttl;
			
		} else if (type == 1 && hasTexSmoke) {
			out_fragColor = texture2D(texSmoke, texCoord);
			out_fragColor.rgb *= 7.5f * ttl;
			out_fragColor *= ttl;
			
		} else {
			vec3 colorNew = vec3(1.0f, 1.0f, 0.0f);
			vec3 colorOld = vec3(1.0f, 0.0f, 0.0f);
			vec3 color = mix(colorOld, colorNew, ttl);
			out_fragColor = vec4(color, ttl);
		}
		
	} else { // if timeToLive <= 0
		discard;
	}
}