#version 330 core

layout (points) in;
layout (triangle_strip, max_vertices = 3) out; // triangles

uniform mat4 projMatrix;

in data {
	float height;
} vertex[];

uniform vec2 scale = vec2(0.1f, 4.0f);

mat2 rot(float angle) {
	return mat2(cos(angle), -sin(angle),
				sin(angle),  cos(angle));
}

void main() {
	if (vertex[0].height > 0) {
	
		vec4 pos = gl_in[0].gl_Position; // in view space
		vec2 v;
		
		v = pos.xy + vec2(-0.5f, -0.5f) * scale; // bottom-left
		gl_Position = projMatrix * vec4(v, pos.zw);
		EmitVertex();
		
		v = pos.xy + vec2(0.5f, -0.5f) * scale; // bottom-right
		gl_Position = projMatrix * vec4(v, pos.zw);
		EmitVertex();
		
		v = pos.xy + vec2(0.0f, 0.5f) * scale; // top
		gl_Position = projMatrix * vec4(v, pos.zw);
		EmitVertex();
		
		EndPrimitive();
	}
}