#version 330 core

layout (triangles) in;
layout (triangle_strip, max_vertices=18) out; // 6 triangles * 3 vertices per triangle = 18

uniform mat4 u_shadowTransforms[6];

out vec4 geom_fragPos; // Output per EmitVertex

void main() {
	for(int face = 0; face < 6; ++face) {
		gl_Layer = face; // What face of the cubemap we're rendering to (GL built-in variable)
		for(int i = 0; i < 3; ++i) { // For each triangle's vertex
			geom_fragPos = gl_in[i].gl_Position;
			gl_Position = u_shadowTransforms[face] * geom_fragPos;
			EmitVertex();
		}    
		EndPrimitive();
	}
}  